//
//  Mesure de la tension et du courant 
//
//  www.wp.thyzoon.fr
//  2020
//

#include "Arduino.h"
#include "Mesure.h"
#include "acsr.h"
#include <math.h>

extern word offset_capteur_acs;       // offset du capteur de courant
//extern word sensibilite_capteur_acs;  // sensibilite du capteur de courant x10   par ex : 205 = 20.5 mV/A
extern word type_acs;                   // Id du type de capteur de courant
extern word type_bat;                   // Id du type de batterie = 2S à 6S


Mesure::Mesure () {
}

// Initialisation CAN et entrées Analogiques
void Mesure::Init(){
   analogReference(DEFAULT); // reference : alimentation 5V 
   
   // Configuration des entrées Analogiques.
   digitalWrite(A0, LOW); 
   pinMode(A0, INPUT);
   digitalWrite(A1, LOW); 
   pinMode(A1, INPUT); 
}

// Calcul de la tension de la batterie 
// valeur de tension sur 10 bits : 0 .. 1023
float Mesure::Tension_batterie (uint16_t tension) {
  float v;
    
  v = tension * VREF / RESOLUTION;
  v = v / (float) R10[type_bat] * (float) (R9[type_bat] + R10[type_bat]);
  
  return v;  
}

// Calcul du  courant consomme sur la batterie 
// valeur de tension sur 10 bits : 0 .. 1023  (CAN)
int Mesure::Courant_batterie (uint16_t tension) {
  int v;
  float u;
  int i;
     
  v = (int) tension - offset_capteur_acs;    // recalage selon offset du capteur de courant
	
  u = (float) v * 1000.0 * VREF / RESOLUTION;            // Calcul de la tension en mV 	
  i = (int) ((u * 1000.0) / ACSsensArray[type_acs] );   // calcul du courant en mA 
  
  return i;  
}
