//
//  Gestion des interruptions 
//  Timer 2 pour acquisition des voies analogique Tension et Courant
//
//  www.wp.thyzoon.fr
//  2020
//

#include "Arduino.h"

byte ITCompteur = 0; // La variable compteur d'interruptions 

//**************************************
// Configuration Timer2 pour une interruption toutes les 4ms
// 

void init_timer2 ()
{
  cli(); // Désactive l'interruption globale
  TCCR2A = 0b00000010;
  TCCR2B = 0b00000110; // Clock 16MHz / 256 soit 16us et WGM22 = 0
  TIMSK2 = 0b00000010; // Interruption locale autorisée par OCIE2A
  OCR2A = 249;         // 250 x 16us = 4ms
  sei(); // Active l'interruption globale
}

//**************************************
// Routine d'interruption sur Timer 2
// acquisition toutes les 200ms
//

ISR(TIMER2_COMPA_vect) {
	
  extern boolean flag_acquisition;   // acquisitions analogiques valides
  extern uint16_t mesure_courant;    // valeur acquistion du courant
  extern uint16_t mesure_tension;    // valeur acquistion de la tension
	
  if (ITCompteur >= 49) { // 50 * 4 ms = 200 ms 
    ITCompteur = 0;
    // Acquisition des voies analogiques
	  // Courant sur ADC0
	  mesure_courant = analogRead(A0); 
	  // Tension sur ADC1
	  mesure_tension = analogRead(A1); 
	  flag_acquisition = true;
    //digitalWrite (13, !digitalRead(13));          // pour vérification période à l'oscillo sur la LED  A SUPPRIMER !
  }	
  else 
	ITCompteur++;
  
}
