// 
// Hott pour telemesure Graupner Hott
// 
// Gestion memorisation en EEPROM
//
// Auteur : www.thyzoon.fr 
// 2016-2020
//

#include "Arduino.h"
#include <EEPROM.h>

// Adresses des parametres en EEPROM, tous les parametres sont stockes sur 16 bits.  
#define adr_eprom_init             0     // For the test for 1st time init of the Arduino (First power on)
#define adr_eprom_mode             2     // mode de RESET de la capacite
#define adr_eprom_v_mini           4     // Tension mini element
#define adr_eprom_type_bat         6     // Nb element batterie / Type batterie
#define adr_eprom_capacite_max     8     // capacite batterie maxi utilisable
#define adr_eprom_alarme_repet    10     // Temps de repetition de l'alarme en secondes
#define adr_eprom_alarme_tension  12     // Activation alarme tension 
#define adr_eprom_alarme_capacite 14     // Activation alarme capacite
#define adr_eprom_capacite_conso  16     // capacite batterie consommee
#define adr_eprom_type_acs        18     // type capateur de courant
#define adr_eprom_offset_acs      20     // offset du capteur de courant ACS (calibre)

//#define adr_eprom_sensibilite_acs xx     // sensibilite du capteur de courant

// -------------------------------------
// Valeurs par defaut stockees en EEPROM
//
#define MODE_RESET      1     // 1 = RESET capacite a chaque mise sous tension / 2 = RESET par bouton poussoir / 3 = Reset sur seuil de tension
#define TENSION_MIN_EL  330   // par elements  330 = 3.30V
#define CAPACITE_MAX    3000  // Capacite maxi a consommer (different de la capacite reelle de la batterie)
#define ALARME_REPET    30    // 30s
#define ALARME_OFF      0     // OFF = 0 

class Mem {
  public:
  Mem ();
  void Init(); 
  
  uint16_t read_eprom(int address);
  void write_eprom(int address,uint16_t val) ;
  
  private:

};
